<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ApplicationStatusType' => '\\StructType\\ApplicationStatusType',
            'ApplicationError' => '\\StructType\\ApplicationError',
            'MessageHeaderType' => '\\StructType\\MessageHeaderType',
            'DocumentInfoType' => '\\StructType\\DocumentInfoType',
            'AdminInfoType' => '\\StructType\\AdminInfoType',
            'GenericPartyType' => '\\StructType\\GenericPartyType',
            'PartyType' => '\\StructType\\PartyType',
            'OrgInfoType' => '\\StructType\\OrgInfoType',
            'IDInfoType' => '\\StructType\\IDInfoType',
            'ContactInfoType' => '\\StructType\\ContactInfoType',
            'CommType' => '\\StructType\\CommType',
            'AddressType' => '\\StructType\\AddressType',
            'PersonNameType' => '\\StructType\\PersonNameType',
            'OtherPartyType' => '\\StructType\\OtherPartyType',
            'BMSObjectType' => '\\StructType\\BMSObjectType',
            'ProcurementRefInfoType' => '\\StructType\\ProcurementRefInfoType',
            'PartCertificationType' => '\\StructType\\PartCertificationType',
            'VehicleInfoType' => '\\StructType\\VehicleInfoType',
            'VehicleDescType' => '\\StructType\\VehicleDescType',
            'OdometerInfoType' => '\\StructType\\OdometerInfoType',
            'QuoteInfoType' => '\\StructType\\QuoteInfoType',
            'FileAttachmentType' => '\\StructType\\FileAttachmentType',
            'DocAttachmentType' => '\\StructType\\DocAttachmentType',
            'ProcurementFolderType' => '\\StructType\\ProcurementFolderType',
            'HeaderType' => '\\StructType\\HeaderType',
            'ProcurementInfoType' => '\\StructType\\ProcurementInfoType',
            'ProcurementPartListType' => '\\StructType\\ProcurementPartListType',
            'ProcurementPartType' => '\\StructType\\ProcurementPartType',
            'PartItemRequestInfoType' => '\\StructType\\PartItemRequestInfoType',
            'PartNumInfoType' => '\\StructType\\PartNumInfoType',
            'PriceInfoType' => '\\StructType\\PriceInfoType',
            'SupplierRsType' => '\\StructType\\SupplierRsType',
            'QuotedPartListType' => '\\StructType\\QuotedPartListType',
            'QuotedPartType' => '\\StructType\\QuotedPartType',
            'AftermarketInfoType' => '\\StructType\\AftermarketInfoType',
            'WarrantyInfoType' => '\\StructType\\WarrantyInfoType',
            'RecycleInfoType' => '\\StructType\\RecycleInfoType',
            'AvailabilityType' => '\\StructType\\AvailabilityType',
            'LineNoteInfoType' => '\\StructType\\LineNoteInfoType',
            'ComplicationListType' => '\\StructType\\ComplicationListType',
            'ComplicationType' => '\\StructType\\ComplicationType',
            'ProcurementNotificationStsRq' => '\\StructType\\ProcurementNotificationStsRq',
            'ProcurementNotificationStsRs' => '\\StructType\\ProcurementNotificationStsRs',
            'SubmitInventory' => '\\StructType\\SubmitInventory',
            'SubmitInventoryResponse' => '\\StructType\\SubmitInventoryResponse',
        );
    }
}
