<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FileAttachmentType StructType
 * @subpackage Structs
 */
class FileAttachmentType extends AbstractStructBase
{
    /**
     * The DocAttachment
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DocAttachmentType[]
     */
    public $DocAttachment;
    /**
     * Constructor method for FileAttachmentType
     * @uses FileAttachmentType::setDocAttachment()
     * @param \StructType\DocAttachmentType[] $docAttachment
     */
    public function __construct(array $docAttachment = array())
    {
        $this
            ->setDocAttachment($docAttachment);
    }
    /**
     * Get DocAttachment value
     * @return \StructType\DocAttachmentType[]|null
     */
    public function getDocAttachment()
    {
        return $this->DocAttachment;
    }
    /**
     * Set DocAttachment value
     * @throws \InvalidArgumentException
     * @param \StructType\DocAttachmentType[] $docAttachment
     * @return \StructType\FileAttachmentType
     */
    public function setDocAttachment(array $docAttachment = array())
    {
        foreach ($docAttachment as $fileAttachmentTypeDocAttachmentItem) {
            // validation for constraint: itemType
            if (!$fileAttachmentTypeDocAttachmentItem instanceof \StructType\DocAttachmentType) {
                throw new \InvalidArgumentException(sprintf('The DocAttachment property can only contain items of \StructType\DocAttachmentType, "%s" given', is_object($fileAttachmentTypeDocAttachmentItem) ? get_class($fileAttachmentTypeDocAttachmentItem) : gettype($fileAttachmentTypeDocAttachmentItem)), __LINE__);
            }
        }
        $this->DocAttachment = $docAttachment;
        return $this;
    }
    /**
     * Add item to DocAttachment value
     * @throws \InvalidArgumentException
     * @param \StructType\DocAttachmentType $item
     * @return \StructType\FileAttachmentType
     */
    public function addToDocAttachment(\StructType\DocAttachmentType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocAttachmentType) {
            throw new \InvalidArgumentException(sprintf('The DocAttachment property can only contain items of \StructType\DocAttachmentType, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DocAttachment[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FileAttachmentType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
